#!/usr/bin/python
"""
Author: Jun Ding
Date: Dec.19, 2011
Version: 1.2
Function: This code is used to get the Cis-regulatory modules for given sequences.
Usage: python crm.py <input_seq_file><support_value><p_value cutoff><output_folder_name><detailed motif combiantions file: Y/N>
"""
import sys,pdb,os,getopt
sys.path.append('code')
import Motif,rmRepeat
from Motif import *
from rmRepeat import *
try:
	opt,args=getopt.getopt(sys.argv[1:],"i:s:c:o:m:l:f:d:")
	flag=0
	for i in opt:
		if i[0]=='-i':
			sys.argv[1]=i[1]
			flag+=1
		if i[0]=='-s':
			sys.argv[2]=i[1]
			flag+=1
		if i[0]=='-c':
			sys.argv[3]=i[1]
			flag+=1
		if i[0]=='-o':
			sys.argv[4]=i[1]
			flag+=1
		if i[0]=='-m':
			sys.argv[5]=i[1]
			flag+=1
		if i[0]=='-l':
			sys.argv[6]=i[1]
			flag+=1
		if i[0]=='-f':
			sys.argv[7]=i[1]
			flag+=1
		if i[0]=='-d':
			sys.argv[8]=i[1]
			flag+=1
			
	if sys.argv[5]=='default':
		sys.argv[5]='data/normalized_transfac_matrices'
	if sys.argv[6]=='default':
		sys.argv[6]='data/lambda'
	#pdb.set_trace()
	if flag>=8:
		#creat output dir- and move input seq to the output dir--------
		if os.path.exists(sys.argv[4]):
			os.system("rm -r "+sys.argv[4])
		os.mkdir(sys.argv[4])
		fn=sys.argv[1].split('/')[-1]
		os.system("cp "+sys.argv[1]+" "+sys.argv[4]+'/')
		#convert line format-----------------------------------------
		inputseq=sys.argv[4]+'/'+fn
		#pdb.set_trace()
		os.system("python code/remove_too_short_seq.py "+inputseq)
		os.system("python code/SEQProcess.py -m 3 "+inputseq)
		os.system("rm "+inputseq)
		os.system("mv "+inputseq+"_LineFormat"+" "+inputseq)
		os.system("echo 'begin scanning sequences'")
		os.system("python code/scan.py "+inputseq+" "+sys.argv[5]+" "+sys.argv[4])
		#pdb.set_trace()
		scanout1=inputseq+"_MotifHits"
		scanout2=inputseq+"_MotifHitsPositions"
		#pdb.set_trace()
		#removing redundant motifs------------------------------------------------------------------------------
		os.system("echo 'removing redundant motif hits...'")
		os.system("python code/Motif.py -m 4 "+sys.argv[5]+" "+scanout1+" "+scanout2+" "+"4")
		non=scanout1+"_4_non_redundant"
		non2=scanout2+"_4_non_redundant"
		#os.remove(scanout1)
		#os.remove(scanout2)
		
		#------removing repeat hits----------------------------------------------------------------------------
		os.system("python code/rmRepeat.py "+non)
		nre=non+"_repeat_removed"
		#------FIM---------------------------------------------------------------------------------------------------
		os.system("chmod +x code/fim_maximal")
		os.system("echo 'generating candidate motif modules...'")
		trans=nre
		out_trans=nre+"_candidate_modules"
		#print("./code/fim_maximal "+trans+" "+sys.argv[2]+" "+out_trans)
		os.system("./code/fim_maximal "+trans+" "+sys.argv[2]+" "+out_trans)
		#pdb.set_trace()
		#------Statistical evaluation-----------------------------------------------------------------------------------------------
		os.system("echo 'statistical evaluation...'")

		os.system("python code/pgc.py "+out_trans+" "+sys.argv[6]+" "+sys.argv[5]+" "+inputseq+" "+sys.argv[3])
		
		out_pgc=out_trans+"_significant"
		out_pgc_2=out_trans+"_corrected_pvalue"
		
	
		#-----Motif ID convertion-----------------------------------------------------------------------------------------------------------
		os.system("python code/sig_module_pvalue.py "+out_pgc+" "+out_pgc_2)
		os.system("rm "+out_trans)
		os.system("rm "+out_pgc_2)
		#os.system("rm "+non)
		#os.system("rm "+non2)
		os.system("rm "+inputseq+"_GeneName")
		os.remove(scanout2)
		os.remove(scanout1)
		os.remove(inputseq)
		os.remove(nre)
		os.rename(out_pgc,sys.argv[4]+"/mod")
	else:
		print("python crm.py \n-i <input sequence> \n-s <support value for frequent pattern mining> \n-c <pvalue cutoff> \n-o <output folder> \n-m <pwm>, 'default': Transfac PWMs, or <your PWMs file> \n-l <lambda>, 'default': defulat lambda used, or <your lambda file> \n-f <format>: txt,xls \n-d <Want Fully detailed motif combination file>: Y,N")
except:
	print("python crm.py \n-i <input sequence> \n-s <support value for frequent pattern mining> \n-c <pvalue cutoff> \n-o <output folder> \n-m <pwm>, 'default': Transfac PWMs, or <your PWMs file> \n-l <lambda>, 'default': defulat lambda used, or <your lambda file> \n-f <format>: txt,xls \n-d<Want Fully detailed motif combination file>: Y,N")


	




